/* 
 * This program inputs a text file and calculates the arithmetic mean  of integers that take
 * part in this file.  There are two versions of the program. The first one reads strings and
 * check if they are integers by using a user-defined function. The second one is written to 
 * examplify the case where program attempts to read integers directly from file. Since the input
 * may not be integer all the time, the second program should also handle non-integer values.
 */

#include <iostream>
#include <fstream>
#include "prompt.h"
#include "strutils.h"

using namespace std;

/*
bool isInteger(string input);
void processByInputCheck(ifstream &input, double &sum, int &numOfIntegers);

int main()
{
	int numOfIntegers=0;
	double average=0;
	double sum=0;
	string word;

	ifstream inFile;

	string fileName = PromptString("enter the name of file: ");

	inFile.open(fileName.c_str());

	if(inFile.fail())
	{
		cout << "Error: Cannot open file "<< fileName<<endl;
		return 0;
	}

	processByInputCheck(inFile, sum, numOfIntegers);

	average = sum / numOfIntegers;
	cout << endl << "average : " << average << endl;
	return 0;
}

void processByInputCheck(ifstream &input, double &sum, int &numOfIntegers)
{
	string word;

	while (input >> word)
	{
		int intVal;

		if (isInteger(word))
		{	
            intVal = atoi(word);
			sum = sum + intVal;
			numOfIntegers++;
		}
	}
}

bool isInteger(string input)
{
	int count = 0;

	bool retVal = false;
	
	for (int i=0; i < input.length(); i++)
	{	
		if (input.substr(i,1) <= "9" && input.substr(i,1) >= "0")
		{
			count++;
		}
	}
	
	if (count == input.length())
	{
		retVal = true;
	}

	return retVal;
}
//*/

void processInput(ifstream &input, double &sum, int &numOfIntegers)
{
	int intVal;
			
	if (input >> intVal)      // read the next number and check if it is really an integer
	{
		sum = sum + intVal;
		numOfIntegers++;
	}			
	else                     //otherwise clear the error flags and skip the invalid entry
	{
		string s;

		input.clear();
		input >> s;
		cout << s << "\tinvalid \n";
	}
}

int main()
{
	int numOfIntegers=0;
	double average=0;
	double sum=0;

	ifstream inFile;

	string fileName = PromptString("enter the name of file: ");

	inFile.open(fileName.c_str());

	if (inFile.fail())
	{
		cout << "Error: Cannot open file " << fileName << endl;	
	}
	else 
	{
		while ( ! inFile.eof() )
		{
			processInput(inFile, sum, numOfIntegers);
		}

		average = sum / numOfIntegers;
		cout << endl <<"average : "<< average << endl;
	}
	return 0;
}


